VERSION 5.00
Begin VB.UserControl Flame 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   ClientHeight    =   1590
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2655
   ScaleHeight     =   1590
   ScaleWidth      =   2655
   ToolboxBitmap   =   "Flame2.ctx":0000
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   240
      Top             =   120
   End
End
Attribute VB_Name = "Flame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Real-time flames by Tanner Helland and Russell Phillips

'This great program creates real-time flames using a simple little
'method I thought up in math one day.  Basically, it runs a loop
'from the bottom of the picture to the top of the picture, drawing
'pixels of varying brightness depending on their height and a
'randomly determined amount.  It takes a little while to get started,
'but once it gets going the flames move pretty realistically.  Also,
'the way it gets the different colors is pretty snazzy - I hate
'trying to use palettes in VB because it's slow and obnoxious and
'tons of work, so I devised this method: double the red value, keep
'the green value the same, and halve the blue value.  This results
'in only red, orange, and yellow shades of pixels.  Cool, huh?  If
'you like what you see, post any comments and/or suggestions at
'planet source code.
'Russell has modified this code so that it can be resized and the
'RGB values can be changed to make the flames ANY color you want.
'Russell has also changed it into an AcitveX control making it much
'easier to use.

'Feel free to use this code however you want, but please give
'me some credit and let me know how you use it.  E-mail me with
'comments or questions at tannerhelland@hotmail.com.

'Also, if you like graphic-based programming, look for some
'of my other projects at www.planet-source-code.com.  Also, feel
'free to e-mail me with any graphic-related (or VB in general)
'questions you may have.

'Read the enclosed game.txt file for info on our current game
'production 'Realms of Time.'

Private Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
'The array for the separate flame pixels
Private FlameArray() As Byte
'counts the frame
Private Frame As Integer
'this number is used to fade the colors to their different
'values, as well as determine the intensity (2nd #)
Const temp = 256 / 50
Dim XSize As Variant, YSize As Variant
Public Red As Integer, Green As Integer, Blue As Integer

Private Sub UserControl_Initialize()
If Red = 0 And Green = 0 And Blue = 0 Then
    Red = 200
    Green = 100
    Blue = 50
End If
'sets the array to the correct size
XSize = (UserControl.Width / 15)
YSize = (UserControl.Height / 15)
ReDim FlameArray(0 To XSize, 0 To YSize) As Byte
'turns the bottom row of flames "on"
For x = 0 To XSize
For y = (YSize - 4) To YSize
    FlameArray(x, y) = 50
Next y
Next x
On Error Resume Next
Kill "Flames.lst"
End Sub

Private Sub Timer1_Timer()
On Error Resume Next
Static x As Integer
Static y As Integer
Static Color As Integer
Static temp2 As Byte
'Makes Sure that RGB Values are above 0%
If Red < 0 Then Red = 0
If Green < 0 Then Green = 0
If Blue < 0 Then Blue = 0
'runs the loop for the y-axis
For y = YSize To 4 Step -1
'runs the loop for the x-axis
For x = 0 To XSize
'set the random degree of cooldown
FlameArray(x, y) = FlameArray(x, y) - Int(Rnd * (175 / YSize))
'set a new random number for the movement
temp2 = Int(Rnd * 3)
'move the pixel in the array
FlameArray(x, y - temp2) = FlameArray(x, y)
'get the color based on the "heat" value
Color = (Int(FlameArray(x, y) * temp))
'draw the pixel
SetPixel UserControl.hDC, x + (Rnd * 2), y, RGB((Red / 100) * Color, (Green / 100) * Color, (Blue / 100) * Color)
'end x loop
Next x
'end y loop
Next y

'make the bottom 4 rows hot again
For x = 0 To XSize
For y = (YSize - 4) To YSize
    FlameArray(x, y) = 50
Next y
Next x
Frame = Frame + 1
UserControl.Refresh
'If you want, you could build a despeckle loop right here that may
'make the flames more realistic.  Maybe someday I'll get around to
'it, but in the meantime feel free to edit this as you like and
'send me the updates.
End Sub

Public Sub SaveBMP()
'this is to save the frames as bitmaps
Static PicName As String
If Frame > 20 Then
    PicName = App.Path + "\Flame" & (Frame - 20) & ".Bmp"
    SavePicture UserControl.Image, PicName
    Open "Flames.lst" For Append As #1
    Print #1, PicName
    Close #1
End If
End Sub

Private Sub UserControl_Resize()
UserControl_Initialize
End Sub
